package com.jiuqi.util.tree;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.tree.ObjectVistor;
import com.jiuqi.util.tree.TreeBuilder;
import com.jiuqi.util.tree.TreeNode;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

public abstract class FastTreeBuilder implements TreeBuilder {
  protected ObjectVistor visitor;
  
  public FastTreeBuilder(ObjectVistor visitor) {
    this.visitor = visitor;
  }
  
  public TreeNode build(Iterator iterator) {
    List<TreeNode> allNodes = new ArrayList();
    HashMap<Object, Object> nodeFinder = new HashMap<Object, Object>();
    while (iterator.hasNext()) {
      Object item = iterator.next();
      TreeNode node = new TreeNode(item);
      allNodes.add(node);
      nodeFinder.put(getObjectCode(item), node);
    } 
    TreeNode root = new TreeNode();
    HashSet<String> paths = new HashSet();
    for (int i = 0; i < allNodes.size(); i++) {
      TreeNode node = allNodes.get(i);
      if (node.getParent() == null) {
        paths.clear();
        while (true) {
          paths.add(getObjectCode(node.getItem()));
          TreeNode parent = (TreeNode)nodeFinder.get(getObjectParent(node.getItem()));
          if (parent == null || paths.contains(getObjectCode(parent.getItem())))
            break; 
          node.setParent(parent);
          node = parent;
        } 
        node = allNodes.get(i);
        if (node.getParent() == null)
          node.setParent(root); 
      } 
    } 
    return root;
  }
  
  protected abstract String getObjectCode(Object paramObject);
  
  protected abstract String getObjectParent(Object paramObject);
}
